;;;; decons/csys - cybernetic communication systems

(defpackage :decons/csys
  (:use :common-lisp)
  (:local-nicknames (:actor :scopes/core/actor)
                    (:util :scopes/util))
  (:export #:neuron #:synapse))

(in-package :decons/csys)

(defun neuron (proc &key state syns env)
  (actor:create 
    (lambda (msg) (funcall proc msg state syns env))))

(defun synapse (rcvr &optional (op #'identity))
  (lambda (msg)
    (actor:send rcvr (op msg))))
